/**************************************************************************
 * HeXHub Winamp Plugin Copyright (C) 2007-2008 Mikhail Polenin           *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This plugin is licensed under the Open Software License 3.0            *
 * Please read the license before making a modification to this plugin.   *
 * Failure to follow the terms of the license will have severe            *
 * consequences                                                           *
 **************************************************************************/

#include "listclass.h"
#include <string>
#include <sstream>


char dir[MAX_PATH];
chatlist *cl = new chatlist;
long winampcmdId = 0;

void HEXHUBAPI onWinampCmd(SDWORD dwCommandId, SDWORD userId, long long *rights, const char *commandParameters, BOOL isPM);

const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	HexHub Hex;
	
	if (Hex.Initialize(HexGetFunction) == false) return 0;

	if((winampcmdId = HexHub::Core::RegisterCommand("winamp", onWinampCmd)) == false) return 0;

	GetModuleFileName(NULL, dir, sizeof(dir));

	int i = strlen(dir);

	for(i = strlen(dir); i >= 0; i--)
	{
		if(dir[i] == '\\')
		{
			dir[i+1] = 0;
			break;
		}
	}

	cl->LoadConfig();
	
	return "Winamp Plugin version 0.1 by The Architect";
}

const char * HEXHUBAPI GetAboutText(void) {
	return "Mikhail Polenin, 2007 - 2008, Release: " __DATE__ " " __TIME__ "";
}

void HEXHUBAPI SaveSettings()
{
	cl->SaveConfig();
}

void HEXHUBAPI UnloadPlugin()
{
	delete cl;
}

BOOL HEXHUBAPI onChatMessage(SDWORD userId,const char *lpBuffer,int bufferSize, userFloodInfo *uFL, floodDefInfo *fDI)
{
	if(lpBuffer[0] == '$') return true;

	char nick[40];
	memset(nick, 0, 40);
	std::string buffer;
	buffer = lpBuffer;

	if(HexHub::Users::NickFromId(userId, nick))
	{
		char *winampstr;
		std::string::size_type st;
		int off = 0;
		int i = 0;
		for (i=0; buffer[i] != 0 && buffer[i] != '\n'; i++) {
			if (buffer[i] == '>') {
				winampstr = &buffer[i+2];
				break;
			}
		}

		for(i=0;winampstr[i] != 0; i++) {
			if(winampstr[i] == '|') {
				winampstr[i] = 0;
				break;
			}
		}

		if(strlen(winampstr) > 400) return true;

		if(winampstr[0] == '!' || winampstr[0] == '+' || winampstr[0] == '/') return true;

		char winmpcpy[400];
		memcpy(winmpcpy, winampstr, 400);
		std::string winampcpy = _strlwr(winmpcpy);
		
		EnterCriticalSection(&cl->cs);
		listitem *pos = cl->first;
		listitem *forward;
		while(pos != 0)
		{
			char poscpy[400];
			memcpy(poscpy, pos->str, 400);
			forward = pos->next;
			st = winampcpy.find(_strlwr(poscpy), 0);
			if(st != std::string::npos)
			{
				if(!HexHub::Users::SetDescription(userId, winampstr))
				{
					std::string snd = "*** Description could not be set to your winamp message. Sending message to all in mainchat instead.|";
					HexHub::Data::SendTo(userId, snd.c_str(), snd.length());
					LeaveCriticalSection(&cl->cs);
					return true;
				}
				else
				{
					char lpbuf[400];
					long buflen = HexHub::Users::GetFullInfo(userId, lpbuf);
					HexHub::Data::SendToAll((const char *)lpbuf, (int)buflen);
					std::string snd = "*** Your description has been set to the winamp message you posted.|";
					HexHub::Data::SendTo(userId, snd.c_str(), snd.length());
					LeaveCriticalSection(&cl->cs);
					return false;
				}
			}
			pos = forward;
		}
		LeaveCriticalSection(&cl->cs);
	}
	return true;
}

void HEXHUBAPI onWinampCmd(SDWORD dwCommandId, SDWORD userId, long long *rights, const char *commandParameters, BOOL isPM)
{
	std::stringstream buff;
	char btnck[40];
	if(!HexHub::Users::NickFromId(0, btnck)) return;

	char usernick[40];
	HexHub::Users::ClientNickFromId(userId, usernick);
	char *val = 0;
	long long userrights = *rights;

	char Parameter[8192];
	memset(Parameter, 0, 8192);
	int i = 0;
	for (i=0; (i < 8191) && (commandParameters[i] != '|') && (commandParameters[i] != 0); i++) Parameter[i] = commandParameters[i];
	for (i=0;Parameter[i] != 0; i++) {
		if (Parameter[i] == ' ') {
			Parameter[i] = 0;
			val = &Parameter[i+1];
			break;
		}
	}
	std::string Paramval;

	if((userrights & ADM6) == false)
	{
		buff << "*** For this command you need the following right(s): adm6 (Can manage hub settings (!set))|";
		HexHub::Data::SendTo(userId, buff.str().c_str(), buff.str().length());
		return;
	}

	if(strcmp("strings", Parameter) == 0)
	{
		if(val == 0)
		{
			buff << "*** You have written an invalid parameter for !winamp strings [param]"
				<< "\r\n\tValid values for !winamp strings [param] are: \r\n\r\n\t\tadd (Add a string)"
				<< "\r\n\t\tdel (Delete a string)\r\n\t\tclear (Clear all strings)\r\n\t\tlst (List all strings)|";
		}
		else
		{
			char *wampstring = 0;
			for(i=0; val[i] != 0; i++) {
				if(val[i] == ' ') {
					val[i] = 0;
					wampstring = &val[i+1];
					break;
				}
			}
			if(strcmp(_strlwr(val), "add") == 0)
			{
				if(wampstring == 0) buff << "*** You have written no string for !winamp strings add [string]|";
				else
				{
					if(cl->Find(wampstring)) buff << "*** There is already a filter for " << wampstring << "|";
					else {
						cl->Add(wampstring);
						buff << "*** Added filter for " << wampstring << "|";
					}
				}
			}
			else if(strcmp(_strlwr(val), "del") == 0)
			{
				if(wampstring == 0) buff << "*** You have written no string for !winamp strings del [string]|";
				else
				{
					if(!cl->Find(wampstring)) buff << "*** Specified filter not found: " << wampstring << "|";
					else {
						cl->Remove(wampstring);
						buff << "*** Deleted filter for " << wampstring << "|";
					}
				}
			}
			else if(strcmp(val, "clear") == 0)
			{
				if(cl->Clear()) buff << "*** Successfully cleared all winamp filter strings.|";
				else buff << "*** Error clearing winamp filter strings.|";
			}
			else if(strcmp(val, "lst") == 0)
			{
				buff << "*** List of all winamp strings:\r\n";
				EnterCriticalSection(&cl->cs);
				listitem *pos = cl->first;
				listitem *forward;
				while(pos != 0)
				{
					forward = pos->next;
					buff << "\r\n\t\t" << pos->str;
					pos = forward;
				}
				LeaveCriticalSection(&cl->cs);
				buff << "|";
			}
		}
	}
	else
	{
		buff << "*** You have written an invalid parameter for !winamp [param]"
			<< "\r\n\tValid values for !winamp [param] are:\r\n\r\n\t\tstrings (Winamp strings)\r\n|";
	}
	HexHub::Data::SendTo(userId, buff.str().c_str(), buff.str().length());
}